#include <verifier/common.h>
#include <verifier/nondet.h>
#include <verifier/memory.h>


/* EMG aliases */
extern void ldv_emg_lpd_main_caller(void);

/* EMG Function declarations */
void ldv_main_1(void *);
int ldv_main(void);

/* EMG function definitions */
/* AUX_FUNC ldv_main_1 */
void ldv_main_1(void *arg0) {
	/* LDV {"thread": 2, "type": "CONTROL_FUNCTION_BEGIN", "comment": "Call exported functions.", "function": "ldv_main_1"} */
	/* LDV {"type": "CONTROL_FUNCTION_INIT_BEGIN", "comment": "Declare auxiliary variables."} */
	/* LDV {"type": "CONTROL_FUNCTION_INIT_END", "comment": "Declare auxiliary variables."} */
	/* LDV {"action": "FUNCTION_CALLS", "type": "CONDITION_BEGIN", "comment": "Call all functions independently."} */
	switch (ldv_undef_int()) {
		case 0: ldv_emg_lpd_main_caller();
		default: ldv_assume(0);
	}
	/* LDV {"action": "FUNCTION_CALLS", "type": "CONDITION_END"} */
	
	/* Exit function at a terminal state */
	return;
	/* End of the process */
	return;
	/* LDV {"comment": "End of control function based on process 'main(generic)'", "type": "CONTROL_FUNCTION_END", "function": "ldv_main_1"} */
}

/* AUX_FUNC ldv_main */
int ldv_main(void) {
	/* LDV {"thread": 1, "type": "CONTROL_FUNCTION_BEGIN", "comment": "Entry point 'ldv_main'", "function": "ldv_main"} */
	/* LDV {"action": "INIT", "type": "CALL_BEGIN", "callback": true, "comment": "Initialize requirement models."} */
	ldv_initialize();
	/* LDV {"action": "INIT", "type": "CALL_END"} */
	/* LDV {"action": "SCENARIOS", "type": "CONDITION_BEGIN", "comment": "Begin Environment model scenarios."} */
	ldv_main_1(0);
	/* LDV {"action": "SCENARIOS", "type": "CONDITION_END"} */
	/* LDV {"action": "FINAL", "callback": true, "type": "CALL_BEGIN", "comment": "Check requirement model final state at the exit if required."} */
	ldv_check_final_state();
	/* LDV {"action": "FINAL", "type": "CALL_END"} */
	return 0;
	/* LDV {"comment": "Exit entry point 'ldv_main'", "type": "CONTROL_FUNCTION_END", "function": "ldv_main"} */
}

